const {pitLib} = require("../helpers/pitLib");
const {User} = require("../model/user-model");
const {Token} = require("../model/TokenModel");
exports.GoogleController={
    fetch:async function (req, res) {
        const myHeaders = new Headers();
        myHeaders.append("Authorization", "Bearer " + req.headers.authorization?.replace('Bearer ',''));

        let data = await fetch("https://www.googleapis.com/oauth2/v2/userinfo", {
            method: "GET",
            headers: myHeaders,
            redirect: "follow"
        })
            .then((response) => response.text())
            .then((result) => {
                return JSON.parse(result)
            })
            .catch((error) => {
                return res.send(pitLib.sendResponse(false, null, error.toString()))
            });
        if (data.error){
            return res.send(pitLib.sendResponse(false,data.error.message))
        }
        let u = await User.findOne({email:data.email}).lean()
        if (u){
            u.token= req.server.jwt.sign(u)
            await Token.create({user:u._id,token:u.token})
            data['exist']=u
        }

        return res.send(pitLib.sendResponse(true, null, data))
    }
}