const {pitLib} = require("../helpers/pitLib");
const {User} = require("../model/user-model");
const {Token} = require("../model/TokenModel");
const create = async (req, res) => {
    r=await pitLib.service.create(User,req.body)
    return res.send(pitLib.sendResponse(!r.err,(r.err)?r.err:null,r?.res))
};
const update = async (req, res) => {
    r=await User.findByIdAndUpdate(req.body._id,req.body)
    return res.send(pitLib.sendResponse(!r.err,(r.err)?r.err:null,r?.res))
};
const login = async (req, res) => {
    let u = await User.findOne({phone: req.body.phone}).select('+password').lean().exec();
    let isCorrect = await pitLib.util.checkHash(req.body.password, u.password)
    if (isCorrect){
        u.token= req.server.jwt.sign(u)
        let token = await Token.create({user:u._id,token:u.token})
    }
    return pitLib.sendResponse(isCorrect,(isCorrect)?null:'Incorrect credentials',(isCorrect)?u:null)
}
const list = async (req, res) => {
    total=parseInt(await User.countDocuments())
    query=[
        {$match: req.body,},
        {$skip: Number(req.query.page-1)*req.query.pagination,},
        {$limit: Number(req.query.pagination),},
        {$lookup:{from: 'countries', localField: 'country', foreignField: '_id', as: 'country',pipeline:[{$project:{name:1}}]}},
        {$lookup:{from: 'users', localField: 'rm', foreignField: '_id', as: 'rm',pipeline:[{$project:{name:1}}]}},
        {$lookup:{from: 'users', localField: 'dietitian', foreignField: '_id', as: 'dietitian',pipeline:[{$project:{name:1}}]}},
        {
            $lookup: {
                    from: 'planmemberships', localField: '_id', foreignField: 'created_by', as: 'membersips',pipeline: [
                        {$lookup:{from: 'plans', localField: 'plan', foreignField: '_id', as: 'plan',pipeline:[{$project:{title:1,validity:1,price:1}}]}},
                ]
            }
        },
    ]

    filtered=await User.aggregate(query)
    r={
        total:total,
        pagination:eval(req.query.pagination),
        page:eval(req.query.page),
        pages:(total/eval(req.query.pagination)).toFixed(),
        filtered:filtered.length,
        data:filtered
    }
    return res.send(pitLib.sendResponse(true,null,r))
}
module.exports ={create,login,list,update}