const {genSalt, hash, compare} = require("bcrypt");
const fastifyJwt = require("@fastify/jwt");
const fs = require('node:fs/promises');
const {isValidObjectId} = require("mongoose");
const mongoose = require("mongoose");
const {User} = require("../model/user-model");
const moment = require("moment");
exports. pitLib = {
    oid:function (_id) {
        return new mongoose.Types.ObjectId(_id);
    },
    sendResponse:function (status=null,message=null,data=null) {
        if (!status){
            status =false;
            if (!message){
                message ='Unable to perform this action'
            }
        } else {
            status =true;
            if (!message){
                message ='Action performed successfully'
            }
        }
        return {status:status,message:message,data:data}
    },
    sendDtResponse:function (draw,recordsFiltered,recordsTotal,data) {
        return {draw:eval(draw),recordsFiltered:eval(recordsFiltered),recordsTotal:eval(recordsTotal),data:data}
    },
    util:{
        trimToCode:function(string,replacer){
            if (!replacer){
                replacer = '_'
            }
            return string.replace(/[^\w ]+/g, "")
                .replace(/ +/g, replacer)
        },
        makeHash:async function (string) {
            const salt = await genSalt(10);
            return await hash(string, salt)
        },
        checkHash:async function (string,hash) {
            return await compare(string, hash)
        },
        uniquid:function () {
            const timestamp = new Date().getTime();
            const randomString = Math.random().toString(36).substring(2, 10); // You can adjust the substring length as needed
            return `${timestamp}_${randomString}`;
        }
    },
    joi:{
        oid:function (value, helper) {
            let r = true
            if (!isValidObjectId(value)) {
                r = helper.message(`${helper.state.path[0]} is not valid object ID`)
            }
            return r
        }
    },
    product:{
        pricer:function (product) {
            let r=null
            if (product.discount.type==='f'){
                r=parseFloat(product.mrp)-parseFloat(product.discount.amount)
            }
            if (product.discount.type==='p'){
                r=parseFloat(product.mrp)-(parseFloat(product.mrp)*parseFloat(product.discount.amount)/100)
            }
            return r.toFixed(2)
        }
    },
    service:{
        create:async function (model, data) {
            let res,err=null
            try {
                res = await model.create(data)
            } catch (e) {
                console.log(e.toString())
                err=e.toString()
            }
            return {res,err}
        },
        list:async function (model, data) {
            let res,err=null
            try {
                res = await model.where(data)
            } catch (e) {
                err=e.toString()
            }
            return {res,err}
        },
    },
    date:{
        addDays:function (date, days) {
            const result = new Date(date);
            result.setDate(result.getDate() + days);
            return result
        },
        toMongoDate:function (date) {
            return new Date(moment(date).format('YYYY-MM-DD')+'T00:00:00.000+00:00')
        }
    },
};