const {mongoose, Schema} = require("mongoose");

const DietPlanSchema  = new mongoose.Schema({
    title:{
        type:String,
        required: true,
    },
    content:{
        type:String,
    },
    plan_membership:{
        type: Schema.Types.ObjectId,
        ref: 'planmemberships'
    },
    target_date:{
        type : Date,
        required: true,
    },
    created_by:{
        type: Schema.Types.ObjectId,
        ref: 'User'
    },
},{
    timestamps: {
        createdAt: 'created_at',
        updatedAt: 'updated_at'
    }
})
const DietPlan = mongoose.model('DietPlan', DietPlanSchema)

module.exports = {DietPlan};