const {mongoose, Schema} = require("mongoose");

const PlanMembershipSchema  = new mongoose.Schema({
    plan:{
        type: Schema.Types.ObjectId,
        ref: 'Plan',
        required:true
    },
    purchase:{
        type: Schema.Types.ObjectId,
        ref: 'PlanPurchase',
        required:true
    },
    expiry:{
        type:Date,
        required:true
    },
    calendar_schedule:[{
        type:Date,
    }],
    created_by:{
        type: Schema.Types.ObjectId,
        ref: 'User'
    },
},{
    timestamps: {
        createdAt: 'created_at',
        updatedAt: 'updated_at'
    }
})
const PlanMembership = mongoose.model('PlanMembership', PlanMembershipSchema)

module.exports = {PlanMembership};