const {mongoose, Schema} = require("mongoose");

const PlanPurchaseSchema  = new mongoose.Schema({
    plan_id:{
        type: Schema.Types.ObjectId,
        ref: 'Plan',
        required: true,
    },
    amount:{
        type:Number,
        required: true,
    },
    amount_paid:{
        type:Number,
        required: true,
    },
    created_at:{
        type:Number,
        required: true,
    },
    payment_link_id:{
        type:String,
        unique:true,
        required: true,
    },
    order_id:{
        type:String,
        required: true,
    },
    reference_id:{
        type:String,
        required: true,
    },
    short_url:{
        type:String,
        required: true,
    },
    currency:{
        type:String,
        required: true,
        enum:['USD','INR']
    },
    created_by:{
        type: Schema.Types.ObjectId,
        ref: 'User'
    },
},{
    timestamps: {
        createdAt: 'created_at',
        updatedAt: 'updated_at'
    }
})
const PlanPurchase = mongoose.model('PlanPurchase', PlanPurchaseSchema)

module.exports = {PlanPurchase};