const {mongoose} = require("mongoose");

const UserSchema  = new mongoose.Schema({
    name:{
        type:String,
        required: true,
    },
    phone:{
        type:String,
        required: true,
        unique: true,
        length:10,
    },
    address:{
        type:Object,
    },
    password: {
        type:String,
        required:true,
    },
    verified:{
        phone:{
            type:Boolean,
            default:false
        },
    }
},{
    timestamps: {
        createdAt: 'created_at',
        updatedAt: 'updated_at'
    }
})
const User = mongoose.model('User', UserSchema)

module.exports = {User};