const {mongoose, Schema} = require("mongoose");

const UserSchema  = new mongoose.Schema({
    name:{
        type:String,
        required: true,
    },
    email:{
        type:String,
        required: true,
        unique:[true,'Email already in use']
    },
    phone:{
        type:String,
        required: true,
        unique: [true,'Phone already in use'],
        length:10,
    },
    address:{
        type:Object,
    },
    password: {
        type:String,
        // required:true,
    },
    role: {
        type:String,
        required:true,
        enum:["user","admin","dietitian","rm"],
        default:"user"
    },
    country:{
        type: mongoose.Schema.Types.ObjectId,
        ref: 'Country'
    },
    rm:{
        type: mongoose.Schema.Types.ObjectId,
        ref: 'User'
    },
    dietitian:{
        type: mongoose.Schema.Types.ObjectId,
        ref: 'User'
    },
    verified:{
        type:[String],
        enum:['phone','email']
    }
},{
    timestamps: {
        createdAt: 'created_at',
        updatedAt: 'updated_at'
    }
})
const User = mongoose.model('User', UserSchema)

module.exports = {User};