const {pitLib} = require("../helpers/pitLib");
const Joi = require("joi");
const {User} = require("../model/user-model");
const create = async (req, res) => {
    let jschema = Joi.object({
        name: Joi.string().required(),
        phone: Joi.number().required().min(1111111111).max(9999999999),
        email: Joi.string().optional().email(),
        country: Joi.string().required()
    }).unknown(true)
    let validation=jschema.validate(req.body)
    if (!validation.error){
        u=await User.findOne({email:req.body.email})
        if (u){
            validation['error']='Email already exists'
        }
        u=await User.findOne({phone:req.body.phone})
        if (u){
            validation['error']='Phone already exists'
        }
    }
    if (validation.error){
        return res.send(pitLib.sendResponse(0, validation.error.message))
    }
};
const login = async (req, res) => {
    jSchema=Joi.object({
        phone:Joi.string().required().length(10),
        password:Joi.string().required()
    })
    validation=jSchema.validate(req.body)
    if (!validation.error){
        r=await User.find({phone:req.body.phone}).countDocuments()
        if (r===0){
            validation.error={message:'Please create account'}
        }
    }
    if (validation.error){
        res.send(pitLib.sendResponse(null,validation.error.message,validation.error))
    }
}
const list = async (req, res) => {
    schema={
        _id:Joi.string().optional().custom(pitLib.joi.oid)
    }
    // RM can see only assigned customer
    if (req.body.role=='rm'){
        schema.role = Joi.string().valid("dietitian", "user")
    }
    jSchema=Joi.object().unknown(true)
    validation=jSchema.validate(req.body)
    if (req.body._id){
        req.body._id=pitLib.oid(req.body._id)
    }
    if (validation.error){
        res.send(pitLib.sendResponse(null,validation.error.message,validation.error))
    }
    if (req.body.rm){
        req.body.rm=pitLib.oid(req.body.rm)
    }
    if (req.body.dietitian){
        req.body.dietitian=pitLib.oid(req.body.dietitian)
    }

}
const update = async (req, res) => {
    jSchema=Joi.object({
        _id:Joi.string().required().custom(pitLib.joi.oid)
    }).unknown(true)
    validation=jSchema.validate(req.body)
    if (!validation.error){
        r=await User.findById(req.body._id)
        if (!r){
            validation.error={message:'User not found'}
        }
    }
    if (req.body._id){
        req.body._id=pitLib.oid(req.body._id)
    }
    if (validation.error){
        res.send(pitLib.sendResponse(null,validation.error.message,validation.error))
    }
}
module.exports = {create,login,list,update}